#ifndef DAMYRANDOM_H_
#define DAMYRANDOM_H_

#define NOCONFLICT 10
#define CHANCE 50

typedef int Pole[8];

#include <cstdlib>

class NodeRandom
{
	private:
		//int _pole[8];
		Pole _pole;

		int CountColisions(int x, int y)
		{
			int result = 0;

			for (int i = 0; i < 8; i++)
			{
				if (i != x)
				{
					if ((y == _pole[i]) || (abs(x-i) == abs(y-_pole[i])))
					{ result++; }
				}
			}

			return result;
		}

	public:
		NodeRandom(Pole& damy) { for (uint i = 0; i < 8; i++) { _pole[i] = damy[i]; } }

		bool Move()
		{
			int mostConflict = GetMostConflicting();
			if (mostConflict == NOCONFLICT) { return true; }
			
			int leastConflict = GetMinConflicting(mostConflict);

			_pole[mostConflict] = leastConflict;
			
			return false;
		}

		friend ostream& operator << (ostream& s, NodeRandom& n)
		{
			for (int i = 7; i >= 0; i--)
			{
				for (int j = 0; j < 8; j++)
				{
					cout << "[";
					if (n._pole[j]==i) { cout << "X"; } else { cout << " "; }
					cout << "]";
				} cout << endl;
			}

			return s;
		}

	private:

		int GetMostConflicting()
		{
			int maxConflicting = 0;
			int conflictCount = 0;
			for (uint i = 0; i < 8; i++)
			{
				int currentConflict = CountColisions(i,_pole[i]);
				if (currentConflict > conflictCount)
				{
					maxConflicting = i;
					conflictCount = currentConflict;
				} 
				else
				if (currentConflict == conflictCount)
				{
					if (rand()%100 >= CHANCE-1)
					{ maxConflicting = i; }
				}
			}

			if (conflictCount == 0) { return NOCONFLICT; }
			else { return maxConflicting; }
		}

		int GetMinConflicting(int dama)
		{
			int minConflicting = 0;
			int conflictCount = 7;
			for (int i = 0; i < 8; i++)
			{
				if (i != _pole[dama])
				{
					int currentConflict = CountColisions(dama,i);
					if (currentConflict < conflictCount)
					{
						minConflicting = i;
						conflictCount = currentConflict;
					}
					else
					if (currentConflict == conflictCount)
					{
						if (rand()%100 >= CHANCE)
						{ minConflicting = i; }
					}

				}
			}

			return minConflicting;
		}

};

#endif
